module Xaases
  module Aws
    class Dynamodb
      attr_reader :name, :keys
      def initialize(name, *keys)
        @name = name
        @keys = keys
      end

      def attribute_definitions
        keys.map do |key, type|
          {
            "AttributeName" => key,
            "AttributeType" => (type == 'integer' ? 'N' : 'S')
          }
        end
      end

      def key_schema
        i = 0
        keys.map do |key, type|
          i += 1
          {
            "AttributeName" => key,
            "KeyType" => (i == 1 ? 'HASH' : 'RANGE')
          }
        end
      end

      def to_hash
        {
          "Type" => 'AWS::DynamoDB::Table',
          "Properties" => {
            "TableName" => name,
            "AttributeDefinitions" => attribute_definitions,
            "KeySchema" => key_schema,
            "ProvisionedThroughput" => {
              "ReadCapacityUnits" => 1,
              "WriteCapacityUnits" => 1
            }
          }
        }
      end
    end
  end
end
