require 'xaases/js'
module Xaases
  module Aws
    class LambdaJs
      attr_reader :minify

      def initialize(minify: true, header: false)
        @minify = minify
        @js = Xaases::Js.new(minify: minify)
        header! if header
      end

      def header!
        @js.strict!
        @js.const(aws: "require('aws-sdk')")
        use_dynamo!
      end

      def use_dynamo!
        @js.const(db: 'new aws.DynamoDB()')
      end

      def export(name, content)
        #f = Xaases::Js::Function.new(:eve, :ctx, :cb)
        f = Xaases::Js::Function.new(:event, :context, :callback)
        f.content = content
        @js.export(name, f)
      end

      def res(status, content)
        #err = err ? err : 'null'
        body = Xaases::Js.new(minify: minify).hash('statusCode' => status, 'body' => content)
        @js.call :callback, 'null', body
      end

      def dynamo_put(table, data, handler)
        params = {
          'TableName' => "'#{table}'",
          'Item' => Xaases::Js.new(minify: minify).hash(data)
        }
        params_js = Xaases::Js.new(minify: minify).hash(params)
        @js.call 'db.put', params_js, handler
      end

      def render
        @js.render
      end
    end
  end
end
