require 'xaases/cli/color'
require 'xaases/error'
require 'xaases/conf'
require 'xaases/serverless'

cmd = ARGV.first
options = ARGV.slice(1..-1)

begin
  case cmd
  when 'table'
    require 'xaases/aws/dynamodb'
    Xaases.table *options
    sls = Xaases::Serverless::Yaml.new('serverless.yml', 'xaases')
    key = options.first + 'DynamoDbTable'
    sls.add_resource key, Xaases::Aws::Dynamodb.new(*options).to_hash
    sls.write

  when 'api'
    require 'xaases/aws/lambda_js'
    Xaases.api *options
    sls = Xaases::Serverless::Yaml.new('serverless.yml', 'xaases')
    name = sls.add_function *options
    sls.write

    need_head = !File.exist?('handler.js')

    # respone
    res = Xaases::Aws::LambdaJs.new(minify: false)
    res.res(200, '"OK."')

    js = Xaases::Aws::LambdaJs.new(minify: false, header: need_head)
    js.export name, res.render
    f = File.open 'handler.js', 'a'
    f.write js.render

  when 'init', 'touch'
    Xaases.init
  else
    require 'xaases/cli/help'
  end
rescue Xaases::Error => e
  Xaases::Color.failure e.message
end
