require 'yaml'

module Xaases
  CONF_NAME = NAME + '.yml'

  def self.init
    YAML.dump({ 'Tables' => {}, 'APIs' => {} }, File.open(CONF_NAME, 'w'))
    Color.warn "Created #{CONF_NAME}"
  end

  def self.load
    begin
      @@config = YAML.load_file(CONF_NAME) || {}
    rescue Errno::ENOENT
      raise Error.new("Require '#{CONF_NAME}' file, you need run at 'xaases init' command.")
    end
  end

  def self.dump
    YAML.dump @@config, File.open(CONF_NAME, 'w')
  end

  def self.edit(&block)
    self.load
    yield @@config
    dump
  end

  def self.table name, *columns
    edit do |config|
      puts Color.yellow "Add table #{name}"
      config['Tables'][name] = columns
    end
  end

  def self.api verb, path
    edit do |config|
      puts Color.yellow "Add API: #{verb} #{path}"
      config['APIs'][verb + ' ' + path] = []
    end
  end
end
